﻿using UnityEngine;
using System.Collections;

public class AnimateLight : MonoBehaviour 
{
    [SerializeField] float intensity;
    [SerializeField] float duration;
    [SerializeField] AnimationCurve curve;

    private float startTime = 0;

	// Use this for initialization
	void Start () 
    {
        startTime = Time.time;
	}
	
	// Update is called once per frame
	void Update () 
    {
        float animationTime = (Time.time - startTime) / duration;

        light.intensity = curve.Evaluate(animationTime) * intensity;
	}
}
