﻿using UnityEngine;
using System.Collections;

public class AnimateMaterialFloat : MonoBehaviour 
{
    [SerializeField] string propertyName;
    [SerializeField] float maxValue;
    [SerializeField] float duration;
    [SerializeField] AnimationCurve curve;

    private float startTime = 0;

    // Use this for initialization
    void Start()
    {
        startTime = Time.time;
    }

    // Update is called once per frame
    void Update()
    {
        float animationTime = (Time.time - startTime) / duration;

        renderer.material.SetFloat(propertyName, curve.Evaluate(animationTime) * maxValue);
    }
}
