﻿using UnityEngine;
using System.Collections;

public class ImpulseOnStart : MonoBehaviour 
{
    [SerializeField] float radius = 1.0f;
    [SerializeField] float impulse = 10.0f;
    [SerializeField] float torqueImpulse = 5.0f;
    [SerializeField] LayerMask mask;

	// Use this for initialization
	void Start () 
    {
         Collider[] hit = Physics.OverlapSphere(transform.position, radius, mask);
         foreach (Collider c in hit)
         {
             if (c.attachedRigidbody)
             {
                 Vector3 diff = c.attachedRigidbody.position - transform.position;
                 c.attachedRigidbody.AddForceAtPosition(diff.normalized * Mathf.Clamp01(diff.magnitude/radius) * impulse, transform.position, ForceMode.Impulse);

                 c.attachedRigidbody.AddTorque(Random.insideUnitSphere * torqueImpulse, ForceMode.Impulse);
             }
         }
	
	}
}
