﻿using UnityEngine;
using System.Collections;

public class HitPoints : MonoBehaviour 
{
    [SerializeField] int initialHitPoints = 10;
    [SerializeField] GameObject hitEffect = null;
    [SerializeField] Transform hitEffectOrigin = null;
    [SerializeField] AudioClip hitClip;

    private int hitPoints;

    public int MaxHP
    {
        get { return initialHitPoints; }
    }
    public int CurrentHP
    {
        get { return hitPoints; }
    }

    void Awake()
    {
        hitPoints = initialHitPoints;
    }

    public void ApplyDamage(int amount, Vector3 damageOrigin)
    {
        hitPoints -= amount;

        if (hitEffect)
        {
            Instantiate(hitEffect, damageOrigin, Quaternion.identity);
        }

        if (audio && hitClip)
            audio.PlayOneShot(hitClip);

        if(hitPoints <= 0)
        {
            BroadcastMessage("MESSAGE_Destroy", SendMessageOptions.DontRequireReceiver);
            GameManager.Instance.RegisterDeath();
            Destroy(gameObject);
        }
    }
}
