﻿using UnityEngine;
using System.Collections;

public class Projectile : MonoBehaviour 
{
    [SerializeField] int damage = 1;
    [SerializeField] GameObject effectOnHit;

    void OnCollisionEnter(Collision hit)
    {
        if (hit.rigidbody)
        {
            HitPoints hp = hit.rigidbody.GetComponent<HitPoints>();

            if(hp)
                hp.ApplyDamage(damage, hit.contacts[0].point);
        }

        if (effectOnHit)
            Instantiate(effectOnHit, transform.position, Quaternion.identity);

        Destroy(gameObject);
    }
}
