﻿using UnityEngine;
using System.Collections;

public class RagdollOnDeath : MonoBehaviour 
{
    [SerializeField] GameObject ragdollPrefab;

    void MESSAGE_Destroy()
    {
        GameObject ragdoll = Instantiate(ragdollPrefab, transform.position, transform.rotation) as GameObject;

        // Copy ragdoll limb positions. Start from bip001
        Transform myRoot = FindChildWithName(transform, "Bip001");
        Transform ragdollRoot = FindChildWithName(ragdoll.transform, "Bip001");

        TrackPlayer.target = ragdollRoot;

        Transform[] myBones = myRoot.GetComponentsInChildren<Transform>();
        Transform[] ragdollBones = ragdollRoot.GetComponentsInChildren<Transform>();

        if (myBones.Length != ragdollBones.Length)
            Debug.LogError("Wrong bone counts");

        for (int i = 0; i < myBones.Length; i++)
        {
            if (myBones[i].gameObject.name != ragdollBones[i].gameObject.name)
                Debug.LogError("Bone Mismatch");

            ragdollBones[i].position = myBones[i].position;
            ragdollBones[i].rotation = myBones[i].rotation;

            if (ragdollBones[i].rigidbody)
                ragdollBones[i].rigidbody.velocity = rigidbody.velocity;
        }
    }

    private Transform FindChildWithName(Transform current, string name)
    {
        if (current.gameObject.name == name)
            return current;

        foreach (Transform t in current)
        {
            Transform result = FindChildWithName(t, name);
            if (result) 
                return result;
        }

        return null;
    }
}
