﻿using UnityEngine;
using System.Collections;

public class SpawnOnDestruction : MonoBehaviour 
{
    [SerializeField] GameObject toSpawn;
    [SerializeField] Transform referenceTransform = null;

    void MESSAGE_Destroy()
    {
        GameObject spawned = Instantiate(toSpawn, 
                                        referenceTransform ? referenceTransform.position : transform.position, 
                                        referenceTransform ?  referenceTransform.rotation : transform.rotation) as GameObject;

        if(rigidbody)
        {
            Rigidbody[] rigidbodies = spawned.GetComponentsInChildren<Rigidbody>();

            foreach(Rigidbody r in rigidbodies)
            {
                r.velocity = rigidbody.velocity;
            }
        }
    }
}
