﻿using UnityEngine;
using System.Collections;

public class TriggerAttack : MonoBehaviour 
{
    [SerializeField] Transform impactPoint;
    [SerializeField] GameObject impactEffect;
    [SerializeField] GameObject impactMissEffect;
    [SerializeField] float impactRadius = 1.5f;
    [SerializeField] float impactImpulse = 10.0f;
    [SerializeField] LayerMask impactMask;

    [SerializeField] AudioClip attackHitClip;
    [SerializeField] AudioClip attackMissClip;


    

    // Called via animation
    void AttackImpact()
    {

        bool targetsHit = false;
        Collider[] hit = Physics.OverlapSphere(impactPoint.position, impactRadius, impactMask);
        foreach (Collider c in hit)
        {
            if (c.attachedRigidbody)
            {
                c.attachedRigidbody.SendMessage("MESSAGE_Impact", SendMessageOptions.DontRequireReceiver);

                float impulse = impactImpulse;
                if (c.attachedRigidbody.mass < 1)
                    impulse *= .1f;

                c.attachedRigidbody.AddForce(impactPoint.forward * impulse, ForceMode.Impulse);
                targetsHit = true;
            }
        }

        GameObject effect = Instantiate(targetsHit ? impactEffect : impactMissEffect) as GameObject;
        effect.transform.position = impactPoint.position;
        effect.transform.rotation = impactPoint.rotation;

        audio.PlayOneShot(targetsHit ? attackHitClip : attackMissClip);

        //TODO: Damage!
    }
}
