﻿using UnityEngine;
using System.Collections;

public class HPDisplay : MonoBehaviour 
{
    [SerializeField] HitPoints reference;
    [SerializeField] HPPointDisplay pointDisplayPrefab;
    [SerializeField] float spacing = 1.0f;

    private HPPointDisplay[] pointDisplays;

	// Use this for initialization
	void Start () 
    {
        Vector3 startPos = transform.position - Vector3.right * (reference.MaxHP-1) * spacing / 2.0f;
        pointDisplays = new HPPointDisplay[reference.MaxHP];
        for (int i = 0; i < reference.MaxHP; i++)
        {
            pointDisplays[i] = Instantiate(pointDisplayPrefab, startPos + Vector3.right * spacing * i, transform.rotation) as HPPointDisplay;
            pointDisplays[i].transform.parent = transform;
        }
	}

    // Update is called once per frame
    void Update()
    {
        for (int i = 0; i < pointDisplays.Length; i++)
        {
            bool hitPointActive = false;
            if(reference)
            {
                hitPointActive = reference.CurrentHP >= i+1;
            }
            pointDisplays[i].PointDisplayed = hitPointActive;
        }
	}
}
