﻿Shader "Custom/BotShader" 
{
    Properties 
    {
		_Color ("Color", Color) = (1,1,1,1)
    	_SpecColor ("Specular Color", Color) = (0.5, 0.5, 0.5, 1)
		_Shininess ("Shininess", Range (0.03, 1)) = 0.078125
    
		_MainTex ("Texture", 2D) = "white" {}
		_EmissionTex ("Texture", 2D) = "white" {}
      
		_FresnelMult ("Fresnel Mult", Float) = 1
		_FresnelPower ("Fresnel Power", Range(0.5,8.0)) = 3.0
		
		_EmissionStrength ("Emission Strength", Range(0,1)) = 0
    }
    SubShader 
    {
		Tags { "RenderType" = "Opaque" }
		CGPROGRAM
		#pragma surface surf BlinnPhong
      
		struct Input 
		{
			float2 uv_MainTex;
			float3 viewDir;
		};
      
		float4 _Color;
      
		half _Shininess;
      
		sampler2D _MainTex;
		sampler2D _EmissionTex;
		sampler2D _BumpMap;
		float _FresnelMult;
		float _FresnelPower;
		float _EmissionStrength;
      
		void surf (Input IN, inout SurfaceOutput o)  
		{
			float3 diffuseColor = tex2D (_MainTex, IN.uv_MainTex).rgb * _Color;
			float emission = tex2D (_EmissionTex, IN.uv_MainTex).r * _EmissionStrength;
			half fresnel = saturate(dot (normalize(IN.viewDir), o.Normal));
			
			o.Albedo = diffuseColor;
			o.Emission = diffuseColor * emission + diffuseColor * pow (fresnel, _FresnelPower) * _FresnelMult;
			o.Gloss = 1.0;
			o.Specular = _Shininess;			
		}
		ENDCG
    }
}