﻿Shader "Custom/ShieldShader" 
{
	Properties 
	{
		_Color("Color", Color) = (1,1,1,1)
		_ColorOuter("Color outer", Color) = (1,1,1,1)
		_MainTex ("Base (RGB)", 2D) = "white" {}
		_PanRate("Pan (XY,ZW)", Vector) = (0,0,0,0)
		_FresnelMult("Fresnel Mult", Float) = 1
		_FresnelPower("Fresnel Power", Float) = 1
		_CloudMult("Cloud Mult", Float) = 1
		_CloudPower("Cloud Power", Float) = 1
	}
	SubShader 
	{
		Tags { "RenderType"="Opaque" }
		LOD 200
		
		CGPROGRAM
		#pragma surface surf Lambert alpha

		struct Input 
		{
			float2 uv_MainTex;
			float3 viewDir;
		};
      
		float4 _Color;
		float4 _ColorOuter;
            
		sampler2D _MainTex;
		float4 _PanRate;
		float _FresnelMult;
		float _FresnelPower;
		float _CloudMult;
		float _CloudPower;

		void surf (Input IN, inout SurfaceOutput o) 
		{
			float c1 = tex2D (_MainTex, IN.uv_MainTex + _PanRate.rg * _Time.g).r;
			float c2 = tex2D (_MainTex, IN.uv_MainTex + _PanRate.ba * _Time.g).r;
			
			half fresnel = 1 - saturate(dot (normalize(IN.viewDir), o.Normal));
			fresnel = saturate(pow (fresnel, _FresnelPower) * _FresnelMult);
			
			float cloud = saturate(pow ((c1 * c2), _CloudPower) * _CloudMult);

			o.Emission	= lerp(_Color,_ColorOuter, fresnel);	
			o.Alpha = (fresnel + cloud) * lerp(_Color.a,_ColorOuter.a, fresnel);

		}
		ENDCG
	} 
	FallBack "Diffuse"
}
